#include <ctime>
#include <iostream>

using namespace std;

struct Driver{
    char lastname[22];
    char name[22];
    char patronymic[22];
};


//=======	class Bus =================
class Bus{
        Driver driver;
        int bus_num;
        int route_num;
        char marka[16];
        int start_year;
        int mileage;
    public:
        Bus();
        int get_route();
        int get_year();
        int get_mileage();
        void show();
};


Bus::Bus(){
    cout << "Введите следующую информацию:\n";
    cout << "Номер автобуса: "; cin >> bus_num;
    cout << "Марка: "; cin.get(); cin.getline(marka, 16);
    cout << "Водитель:\n";
    cout << "Фамилия: "; cin.get(); cin.getline(driver.lastname, 22);
    cout << "Имя: "; cin.get(); cin.getline(driver.name, 22);
    cout << "Отчество: "; cin.get(); cin.getline(driver.patronymic, 22);
    cout << "Номер маршрута: "; cin >> route_num;
    cout << "Год начала эксплуатации: "; cin >> start_year;
    cout << "Пробег: "; cin >> mileage;
}


void Bus::show(){
    cout<<"Автобус №"<<bus_num<<endl;
    cout<<"--------------\nМарка: "<<marka<<endl;
    cout<<"Водитель: "<<driver.lastname<<" "<<driver.name<<" "<<driver.patronymic<<endl;
    cout<<"Маршрут №:"<<route_num<<endl;
    cout<<"Год начала эксплуатации:"<<start_year<<endl;
    cout<<"Пробег:"<<mileage<<endl;
}


int Bus::get_route(){
    return route_num;
}


int Bus::get_year(){
    return start_year;
}


int Bus::get_mileage(){
    return mileage;
}


void route_search(Bus spis[], int n){
    int route;
    cout<<"Маршрут:";
    cin >> route;
    for(int i=0;i<n;i++){
        if(route == spis[i].get_route()){
            spis[i].show();
            cout<<"=============================="<<endl;
        }
    }
}


void search_for_old (Bus spis[], int n, int age){
    time_t t = time(nullptr);
    tm* now = localtime(&t);
    int year = 1900 + now->tm_year;
    cout << "Автобусы старше " << age << " лет: " << endl;
    for(int i=0;i<n;i++){
        if(year-spis[i].get_year() > age){
            spis[i].show();
            cout<<"=============================="<<endl;
        }
    }
}


void mileage_search (Bus spis[], int n, int mil){
    cout << "Автобусы с пробегом больше " << mil << "км.: " << endl;
    for(int i=0;i<n;i++){
        if(spis[i].get_mileage() > mil){
            spis[i].show();
            cout<<"=============================="<<endl;
        }
    }
}


//========= main ================
int main(){
    Bus *spis;
    int n;
    cout<<"Введите кол-во автобусов: "; cin>>n;
    spis=new Bus[n];
    for(int i=0;i<n;i++){
        cout<<"=============================="<<endl;
        spis[i].show();
        cout<<"=============================="<<endl;
    }
    route_search(spis, n);
    search_for_old(spis, n, 10);
    mileage_search(spis, n, 10000);
    delete [] spis;
}